﻿Type=StaticCode
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#IgnoreWarnings: 12
Private Sub Process_Globals
	Private bc As List
End Sub

Sub Create
	bc.Initialize
	bc.Add(BlockGen.Genesis_Block)
End Sub

Sub LastBlock As Block
	If bc.Size == 0 Then Return Null
	'-------------------------------
	Return bc.Get(bc.Size - 1)
End Sub

Sub AddBlock As Boolean
	Dim b = LastBlock As Block
	If b == Null Then Return False
	'-----------------------------
	bc.Add(BlockGen.Next_Block(b))
	'Tell everyone about it!
	Log("Block #" & b.Index & " has been added to the blockchain!")
	Log("Hash: " & b.Hash)
	Log("----------------------------------------------------------------------")
	Return True
End Sub

Sub GetBlock(index As Int) As Block
	Return bc.Get(index)
End Sub

Sub VerifyBlockIntegrity(index As Int) As Boolean
	If index >= bc.Size - 1 Then
		Log("This block cannot be verified.")
	End If
	Dim thisBlock = bc.Get(index    ) As Block
	Dim nextBlock = bc.Get(index + 1) As Block
	If thisBlock.Hash == nextBlock.Previous_Hash Then
		Log("Block #" & index & ": OK")
		Return True
	End If
	Log("Block #" & index & ": CORRUPT")
	Return False
End Sub